sets
t  Conjunto de tiempos      /t1*t48/
i  Conjunto de nodos        /N1*N21/
g  Conjunto de generadores  /G1/
gd Conjunto de gen. disy.   /GD1*GD2/
b  Conjunto de baterias     /B1*B3/
map(g,i)  Asocia nodos y generadores /G1.N1/
mapgd(gd,i)  Asocia nodos y generadores /GD1.N12,GD2.N21/
mapb(b,i)  Asocia nodos y generadores /B1.N7,B2.N10,B3.N15/;

Scalars
Dt Delta de tiempo considerado                  /0.50/
Sb Base of power [kW]   /100/
alpha Coeficiente de potencia  /0/;

alias(i,j);

Table Gbus(i,j)
    N1                       N2                      N3                       N4                      N5                      N6                       N7                       N8                       N9                       N10                      N11                      N12                      N13                      N14                      N15                      N16                      N17                      N18                      N19                      N20                      N21
N1  373.864430468204        -188.679245283019        -185.185185185185        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N2  -188.679245283019        188.679245283019        0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N3  -185.185185185185        0                       829.319885923660         -185.185185185185       0                       0                        -270.270270270270        0                        0                        -188.679245283019        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N4  0                        0                       -185.185185185185        539.993775287893        -158.730158730159       -196.078431372549        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N5  0                        0                       0                        -158.730158730159       158.730158730159        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N6  0                        0                       0                        -196.078431372549       0                       196.078431372549         0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N7  0                        0                       -270.270270270270        0                       0                       0                        535.741437640172        -126.582278481013         -138.888888888889        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N8  0                        0                       0                        0                       0                       0                        -126.582278481013        126.582278481013         0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N9  0                        0                       0                        0                       0                       0                        -138.888888888889        0                        138.888888888889         0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N10 0                        0                       -188.679245283019        0                       0                       0                        0                        0                        0                        572.319067730704         -263.157894736842        0                        0                        -120.481927710843        0                        0                        0                        0                        0                        0                        0
N11 0                        0                       0                        0                       0                       0                        0                        0                        0                        -263.157894736842        517.945301422983         -126.582278481013        -128.205128205128        0                        0                        0                        0                        0                        0                        0                        0
N12 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        -126.582278481013        126.582278481013         0                        0                        0                        0                        0                        0                        0                        0                        0
N13 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        -128.205128205128        0                        128.205128205128         0                        0                        0                        0                        0                        0                        0                        0
N14 0                        0                       0                        0                       0                       0                        0                        0                        0                        -120.481927710843        0                        0                        0                        402.533209762125         -153.846153846154        0                        0                        0                        -128.205128205128        0                        0
N15 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        -153.846153846154        310.096153846154         -156.250000000000        0                        0                        0                        0                        0
N16 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        -156.250000000000        414.841925258592         -135.135135135135        -123.456790123457        0                        0                        0
N17 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -135.135135135135        135.135135135135         0                        0                        0                        0
N18 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -123.456790123457        0                        123.456790123457         0                        0                        0
N19 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        -128.205128205128        0                        0                        0                        0                        369.203966764942        -119.047619047619        -121.951219512195
N20 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -119.047619047619        119.047619047619        0
N21 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -121.951219512195        0                        121.951219512195;

Table Load(i,*)
    PL
N1  0.00
N2  0.25
N3  0.00
N4  0.00
N5  0.04
N6  0.14
N7  0.00
N8  0.13
N9  0.32
N10 0.00
N11 0.17
N12 0.00
N13 0.31
N14 0.00
N15 0.00
N16 0.00
N17 0.17
N18 0.13
N19 0.04
N20 0.10
N21 0.00
;
Table CV(t,*)
      Cost   Var
t1    0.770  0.17
t2    0.740  0.14
t3    0.710  0.11
t4    0.700  0.11
t5    0.690  0.11
t6    0.695  0.10
t7    0.700  0.09
t8    0.710  0.09
t9    0.720  0.09
t10   0.760  0.10
t11   0.800  0.11
t12   0.835  0.13
t13   0.870  0.14
t14   0.890  0.17
t15   0.910  0.20
t16   0.895  0.25
t17   0.880  0.31
t18   0.895  0.34
t19   0.910  0.36
t20   0.910  0.39
t21   0.910  0.42
t22   0.910  0.43
t23   0.910  0.45
t24   0.905  0.46
t25   0.900  0.47
t26   0.900  0.47
t27   0.895  0.45
t28   0.890  0.42
t29   0.895  0.43
t30   0.900  0.45
t31   0.900  0.45
t32   0.900  0.45
t33   0.925  0.45
t34   0.950  0.45
t35   0.945  0.45
t36   0.940  0.45
t37   0.925  0.43
t38   0.910  0.42
t39   0.905  0.46
t40   0.900  0.50
t41   0.875  0.49
t42   0.850  0.47
t43   0.825  0.45
t44   0.800  0.42
t45   0.755  0.38
t46   0.710  0.34
t47   0.685  0.29
t48   0.660  0.25
;
Table Gend(t,gd)
           GD1             GD2
t1         0.447162802     0
t2         0.444794189     0
t3         0.428898964     0
t4         0.430308162     0
t5         0.427696935     0
t6         0.444999484     0
t7         0.483273901     0
t8         0.535617757     0
t9         0.553530262     0
t10        0.575795405     0
t11        0.558360108     0
t12        0.521719040     0
t13        0.526154329     0
t14        0.507812624     0
t15        0.543560486     0.022562253
t16        0.580833511     0.026190200
t17        0.583740159     0.037823805
t18        0.599368804     0.076478585
t19        0.619076643     0.136602230
t20        0.638573576     0.236650446
t21        0.657703393     0.262406551
t22        0.674897192     0.312778929
t23        0.681922874     0.418934549
t24        0.685830403     0.510435716
t25        0.686664699     0.533146744
t26        0.692195818     0.576695110
t27        0.692962622     0.566338331
t28        0.698266347     0.526911725
t29        0.700207454     0.478315007
t30        0.705449754     0.399022311
t31        0.706286339     0.422754017
t32        0.703511313     0.345114575
t33        0.697286892     0.289001440
t34        0.689702606     0.172905537
t35        0.656522934     0.102142807
t36        0.618999211     0.036179599
t37        0.558782236     0
t38        0.488250210     0
t39        0.500643478     0.000192570
t40        0.511403821     0
t41        0.503498789     0
t42        0.518381714     0
t43        0.508453869     0
t44        0.498286699     0
t45        0.496524562     0
t46        0.484902028     0
t47        0.485387203     0
t48        0.482089705     0
;
TABLE Batt(b,*) Battery operation rank
      SoCmin  SoCmax  SoCi   SoCf   Phi     PbD          PbC
*     [%]     [%]     [%]     [%]
B1    0.0     1       0.5    0.5    0.8     0.3125      -0.25
B2    0.0     1       0.5    0.5    1.0     0.2500      -0.20
B3    0.0     1       0.5    0.5    1.0     0.2500      -0.20
;

TABLE CapGen(gd,*)
     Cap
GD1  0.4
Gd2  0.5

Variables
z Objective function variable
v(i,t)    Nodal voltage [p.u]
p(g,t)    Conventional power generation [p.u]
pgd(gd,t) Distributed power generation [p.u]
SoC(b,t)  State-of-Charge of the battery
pb(b,t)   Power input\output in the battery [p.u];
pgd.lo(gd,t) = 0;               pgd.up(gd,t) = 1*CapGen(gd,'Cap')*Gend(t,gd);
pb.lo(b,t) = Batt(b,'PbC');     pb.up(b,t) =   1*Batt(b,'PbD');
SoC.lo(b,t) = Batt(b,'SoCmin'); SoC.up(b,t) =  Batt(b,'SoCmax');
SoC.fx(b,'t1') =  Batt(b,'SoCi'); SoC.fx(b,'t48') = Batt(b,'SoCf');
v.lo(i,t) = 0.90; v.up(i,t) = 1.05;
v.fx('N1',t) = 1.0; p.lo(g,t) = 0;
Equations
Fo  Objetive function equaation
Balance(i,t) Power balance
States(b,t) State of the battery;
Fo.. z =e= Sb*sum(g,sum(t,CV(t,'Cost')*p(g,t)))*Dt;
Balance(i,t).. sum(g$map(g,i),p(g,t)) + 1*sum(gd$mapgd(gd,i),pgd(gd,t)) + 1*sum(b$mapb(b,i),pb(b,t)) - Load(i,'PL')*(CV(t,'Var'))*(v(i,t)**alpha)
               =e= sum(j,Gbus(i,j)*v(i,t)*v(j,t));
States(b,t)$(ord(t) gt 1)..  SoC(b,t) =e= SoC(b,t-1) - Batt(b,'Phi')*Pb(b,t)*Dt;
Model   Eco_Disp_Batts /all/;
solve   Eco_Disp_Batts using NLP minimizing z;
display z.l,soc.l;
